summaryrefslogtreecommitdiffstats
path: root/libgphoto2
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2007-09-16 17:54:08 +0000
committer Eric Hameleers <alien@slackware.com>2007-09-16 17:54:08 +0000
commit234a4db69455663c2e370e819a25c04f76bed865 (patch)
tree93544395475a6a29abbb683f277723838e12fd15 /libgphoto2
parentbb77c16ca36a7f67342984823056707c3b61fd24 (diff)
downloadasb-234a4db69455663c2e370e819a25c04f76bed865.tar.gz
asb-234a4db69455663c2e370e819a25c04f76bed865.tar.xz
Updated for Slackware 12.0 with HAL/udev
Diffstat (limited to 'libgphoto2')
-rwxr-xr-xlibgphoto2/build/libgphoto2.SlackBuild285
1 files changed, 127 insertions, 158 deletions
diff --git a/libgphoto2/build/libgphoto2.SlackBuild b/libgphoto2/build/libgphoto2.SlackBuild
index 1cf1cc30..fb85ed19 100755
--- a/libgphoto2/build/libgphoto2.SlackBuild
+++ b/libgphoto2/build/libgphoto2.SlackBuild
@@ -1,13 +1,33 @@
#!/bin/sh
# $Id$
-# Copyright (c) 2006 Eric Hameleers <alien@slackware.com>
+# Copyright (c) 2007 Eric Hameleers <alien@slackware.com>
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
# -----------------------------------------------------------------------------
#
# Slackware SlackBuild script
# ===========================
# By: Eric Hameleers <alien@slackware.com>
# For: libgphoto2
-# URL: http://gphoto.org/
+# Descr: a library to access digital cameras
+# URL: http://www.gphoto.org/
# Needs:
# Changelog:
# 2.1.6-1: 27/Sep/2005 by Eric Hameleers <alien@slackware.com>
@@ -20,50 +40,54 @@
# 2.2.1-1: 08/oct/2006 by Eric Hameleers <alien@slackware.com>
# * Update.
# Rewrote the SlackBuild for Slackware 10.x/11.x compatibility.
+# 2.4.0-1: 16/Sep/2007 by Eric Hameleers <alien@slackware.com>
+# * Update for Slackware 12.0
+# With thanks to Frank Caraballo and Michael Wagner whose
+# contribution to SlackBuilds.org helped in this script.
#
-# Run 'sh SlackBuild --cleanup' to build a Slackware package.
+# Run 'sh libgphoto2.SlackBuild --cleanup' to build a Slackware package.
# The package (.tgz) plus descriptive .txt file are created in /tmp .
# Install using 'installpkg'.
#
# -----------------------------------------------------------------------------
-# --- INIT ---
# Set initial variables:
PRGNAM=libgphoto2
-VERSION=2.2.1
+VERSION=${VERSION:-2.4.0}
ARCH=${ARCH:-i486}
-BUILD=1
+BUILD=${BUILD:-1}
DOCS="ABOUT-NLS AUTHORS CHANGES COPYING ChangeLog HACKING INSTALL \
MAINTAINERS NEWS README TESTERS"
-SOURCE="${PRGNAM}-${VERSION}.tar.gz"
-SRCURL="http://dl.sourceforge.net/sourceforge/gphoto/${PRGNAM}-${VERSION}.tar.gz"
+# Where do we look for sources?
+CWD=$(pwd)
+SRCDIR=$(dirname $0)
+[ "${SRCDIR:0:1}" == "." ] && SRCDIR=${CWD}/${SRCDIR}
# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
TMP=${TMP:-/tmp/build}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}
+# Input URL: http://dl.sourceforge.net/gphoto/libgphoto2-2.4.0.tar.bz2
+SOURCE="$SRCDIR/${PRGNAM}-${VERSION}.tar.bz2"
+SRCURL="http://dl.sourceforge.net/gphoto/${PRGNAM}-${VERSION}.tar.bz2"
+
##
## --- with a little luck, you won't have to edit below this point --- ##
##
-# Where do we look for sources?
-CWD=`pwd`
-SRCDIR=`dirname $0`
-[ "${SRCDIR:0:1}" == "." ] && SRCDIR=${CWD}/${SRCDIR}
-
# Exit the script on errors:
set -e
-trap 'echo "$0 FAILED!" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+trap 'echo "$0 FAILED at line $LINENO!" | tee $OUTPUT/error-${PRGNAM}.log' ERR
# Catch unitialized variables:
set -u
P1=${1:-1}
# Slackware 11 and up need other option (gcc > 3.3.x)
-if [ `gcc -dumpversion | tr -d '.' |cut -c 1-2` -gt 33 ]; then
+if [ $(gcc -dumpversion | tr -d '.' |cut -c 1-2) -gt 33 ]; then
MOPT=tune
else
MOPT=cpu
@@ -90,42 +114,28 @@ case "$ARCH" in
;;
esac
-if [ ! -d $TMP/tmp-$PRGNAM ]; then
- mkdir -p $TMP/tmp-$PRGNAM # location to build the source
-elif [ "$P1" != "--oldbuild" ]; then
- # If the "--oldbuild" parameter is present, we keep
- # the old build files and continue;
- # By default we remove the remnants of previous build and continue:
- rm -rf $TMP/tmp-$PRGNAM/*
-fi
-
-if [ "$PKG" = "" -o "$PKG" = "/" ] ; then
- echo "Please provide a sane value for the variable 'PKG'."
- exit 1
-elif [ ! -d $PKG ]; then
- mkdir -p $PKG # place for the package to be built
-else
- rm -rf $PKG/* # We always erase old package's contents:
-fi
-
-if [ ! -d $OUTPUT ]; then
- mkdir -p $OUTPUT # place for the package to be saved
-fi
-
+# Create working directories:
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+rm -rf $TMP/tmp-$PRGNAM/* # we remove the remnants of previous build
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # We always erase old package's contents:
+mkdir -p $OUTPUT # place for the package to be saved
-# --- SOURCE FILE AVAILABILITY ---
-
-if ! [ -f ${SRCDIR}/${SOURCE} ]; then
+# Source file availability:
+if ! [ -f ${SOURCE} ]; then
if ! [ "x${SRCURL}" == "x" ]; then
- echo "Source '${SOURCE}' not available yet... will download now:"
- wget -nv -O "${SRCDIR}/${SOURCE}" "${SRCURL}" || true
- if [ $? -ne 0 ]; then
- echo "Downloading '${SOURCE}' failed... aborting the build."
- mv -f "${SRCDIR}/${SOURCE}" "${SRCDIR}/${SOURCE}".FAIL
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename $SOURCE)"
+ echo "Source '$(basename ${SOURCE})' not available yet..."
+ echo "Will download file to $(dirname $SOURCE)"
+ wget -nv --connect-timeout=30 -O "${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
+ echo "Downloading '$(basename ${SOURCE})' failed... aborting the build."
+ mv -f "${SOURCE}" "${SOURCE}".FAIL
exit 1
fi
else
- echo "File '${SOURCE}' not available... aborting the build."
+ echo "File '$(basename ${SOURCE})' not available... aborting the build."
exit 1
fi
fi
@@ -135,166 +145,125 @@ if [ "$P1" == "--download" ]; then
exit 0
fi
-
# --- PACKAGE BUILDING ---
echo "++"
echo "|| $PRGNAM-$VERSION"
echo "++"
-cd $PKG
-
-# Explode the package framework:
-if [ -f $SRCDIR/_$PRGNAM.tar.gz ]; then
- explodepkg $SRCDIR/_$PRGNAM.tar.gz
-fi
-
cd $TMP/tmp-$PRGNAM
-
-
-# --- TARBALL EXTRACTION,PATCH,MODIFY ---
-
echo "Extracting the source archive(s) for $PRGNAM..."
-if `file $SRCDIR/${SOURCE} | grep -q ": bzip2"`; then
- tar -xjvf $SRCDIR/${SOURCE} || true
-elif `file $SRCDIR/${SOURCE} | grep -qi ": zip"`; then
- unzip $SRCDIR/${SOURCE} || true
-elif `file $SRCDIR/${SOURCE} | grep -qi ": 7-zip"`; then
- 7za -x $SRCDIR/${SOURCE} || true
-else
- tar -xzvf $SRCDIR/${SOURCE} || true
-fi
-if [ $? -ne 0 ]; then
- echo "Error in unpacking '${SOURCE}!' Aborting..."
- exit $?
+if $(file ${SOURCE} | grep -q ": bzip2"); then
+ tar -xjvf ${SOURCE}
+elif $(file ${SOURCE} | grep -q ": gzip"); then
+ tar -xzvf ${SOURCE}
fi
cd ${PRGNAM}-${VERSION}
-
-chown -R root.root *
-find . -perm 777 -exec chmod 755 {} \;
-
-
-# --- BUILDING ---
+chown -R root:root .
+chmod -R u+w,go+r-w,a-s .
echo Building ...
-
-if [ ! -d /usr/include/gphoto2 ]; then
- mkdir -p /usr/include/gphoto2
- find libgphoto2 -type f -name "*.h" -exec cp {} /usr/include/gphoto2/ \;
- find libgphoto2_port/libgphoto2_port -type f -name "*.h" -exec cp {} /usr/include/gphoto2/ \;
- CLEANUP_INCL="yes"
-else
- CLEANUP_INCL="no"
-fi
-
+udevscriptdir="/lib/udev" \
+utilsdir="/usr/bin" \
LDFLAGS="$SLKLDFLAGS" \
CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
./configure --prefix=/usr \
--libdir=/usr/lib${LIBDIRSUFFIX} \
--localstatedir=/var \
--sysconfdir=/etc \
- --with-drivers=all \
- --with-doc-dir=/usr/doc/${PRGNAM}-${VERSION} \
+ --disable-static \
+ --mandir=/usr/man \
+ --with-doc-dir=/usr/doc/$PRGNAM-$VERSION \
+ --program-prefix="" \
+ --program-suffix="" \
+ --build=$ARCH-slackware-linux \
2>&1 | tee $OUTPUT/configure-${PRGNAM}.log
make 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
#
# Install all the needed stuff to the package dir
#
-# Use installwatch if available:
-which installwatch > /dev/null 2>&1
-if [ $? == 0 ]; then
+# Use installwatch if available, to produce a logfile of the installation
+# process that is more easily readable:
+if $(which installwatch > /dev/null 2>&1); then
installwatch -o $OUTPUT/install-${PRGNAM}.log make DESTDIR=$PKG install
else
make DESTDIR=$PKG install 2>&1 |tee $OUTPUT/install-${PRGNAM}.log
fi
-# Create a link to print-usb-usermap and print-camera-list
-mkdir -p $PKG/usr/bin
-(cd $PKG/usr/bin
- ln -sf ../lib/libgphoto2/print-usb-usermap
- ln -sf ../lib/libgphoto2/print-camera-list
-)
-
-[ "$CLEANUP_INCL" == "yes" ] && rm -rf /usr/include/gphoto2
-
-
-# --- DOINST.SH ---
-
+# Install "dummy" udev rules files and HAL device information files so
+# they will be removed later if the package is uninstalled.
+# The post-install script will append auto-generated rules to these files
+mkdir -p $PKG/etc/udev/rules.d
+mkdir -p $PKG/usr/share/hal/fdi/information/20thirdparty
+
+cat <<-EOF > $PKG/etc/udev/rules.d/90-libgphoto2.rules
+ # DO NOT EDIT THIS FILE!
+ # Any custom changes will be lost if the libgphoto2 package is upgraded.
+
+ EOF
+
+cat <<-EOF > $PKG/usr/share/hal/fdi/information/20thirdparty/10-camera-libgphoto2.fdi
+ <!-- DO NOT EDIT THIS FILE! -->
+ <!-- Any custom changes will be lost if the libgphoto2 package is upgraded. -->
+
+ EOF
+
+cat <<-EOF > $PKG/usr/share/hal/fdi/information/20thirdparty/10-camera-libgphoto2-device.fdi
+ <!-- DO NOT EDIT THIS FILE! -->
+ <!-- Any custom changes will be lost if the libgphoto2 package is upgraded. -->
+
+ EOF
+
+# Let the post-install generate the information for UDEV and HAL files:
mkdir -p $PKG/install
cat <<-EOT > $PKG/install/doinst.sh
- # Install usbcam script for hotplug and udev
- if [ ! -f etc/hotplug/usb/usbcam ]; then
- mkdir -p etc/hotplug/usb
- cat usr/doc/$PRGNAM-$VERSION/linux-hotplug/usbcam.group | sed -e "s/^GROUP=.*$/GROUP=video/" > etc/hotplug/usb/usbcam
- chmod 755 etc/hotplug/usb/usbcam
- fi
- # Write hotplug usermap file
- if [ ! -s etc/hotplug/usb/usbcam.usermap ]; then
- ./usr/bin/print-camera-list usb-usermap > etc/hotplug/usb/usbcam.usermap
- fi
- # Write udev rules for gphoto2
- VUDEV=$( /usr/bin/udevinfo -V | sed -e 's/.* \([^ ]*\)/\1/' )
- if ! \`ls etc/udev/rules.d/ | grep -q libgphoto2\`; then
- if [ \$VUDEV -lt 98 ]; then
- ./usr/bin/print-camera-list udev-rules /etc/hotplug/usb/usbcam > etc/udev/rules.d/libgphoto2.rules
- else
- ./usr/bin/print-camera-list udev-rules-0.98 /etc/hotplug/usb/usbcam > etc/udev/rules.d/libgphoto2.rules
- fi
- fi
+ # Generate udev rules files
+ usr/bin/print-camera-list udev-rules mode 0660 group plugdev \
+ >> etc/udev/rules.d/90-libgphoto2.rules
+
+ # Install hal device information files
+ usr/bin/print-camera-list hal-fdi \
+ >> usr/share/hal/fdi/information/20thirdparty/10-camera-libgphoto2.fdi
+ usr/bin/print-camera-list hal-fdi-device \
+ >> usr/share/hal/fdi/information/20thirdparty/10-camera-libgphoto2-device.fdi
+
EOT
-
-# --- DOCUMENTATION ---
-
+# Add documentation:
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
-# Remove cruft directory
-rm -rf $PKG/usr/doc/$PRGNAM-$VERSION/apidocs.html
+# Remove cruft
+rm -r $PKG/usr/doc/$PRGNAM-$VERSION/apidocs.html
chmod -R a-w $PKG/usr/doc/$PRGNAM-$VERSION/*
-# Move incorrectly installed man pages
-mv $PKG/usr/share/man $PKG/usr/ && rmdir $PKG/usr/share || true
-# Compress the man page(s)
-find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
-
-# Strip binaries
-( cd $PKG
- find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
- find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
-)
-
-
-# --- OWNERSHIP, RIGHTS ---
-
-chmod -R o-w $PKG
-
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
-# --- PACKAGE DESCRIPTION ---
+# Strip binaries:
+cd $PKG
+find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+cd -
+# Add a package description:
mkdir -p $PKG/install
cat $SRCDIR/slack-desc > $PKG/install/slack-desc
if [ -f $SRCDIR/doinst.sh ]; then
cat $SRCDIR/doinst.sh >> $PKG/install/doinst.sh
fi
-if [ -f $SRCDIR/slack-required ]; then
- cat $SRCDIR/slack-required > $PKG/install/slack-required
-fi
-
-
-# --- BUILDING ---
# Build the package:
cd $PKG
-makepkg --linkadd y --chown n --prepend $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
-(cd $OUTPUT && md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz.md5)
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz.md5
+cd -
cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.txt
-if [ -f $PKG/install/slack-required ]; then
- cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.dep
-fi
-
-
-# --- CLEANUP ---
# Clean up the extra stuff:
if [ "$P1" = "--cleanup" ]; then